﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace Persistence {

  public class Root {

    [Storable]
    public int[] i = new int[] { 3, 4, 5, 6 };
    [Storable]
    public string s;
    [Storable]
    public ArrayList intArray = new ArrayList(new int[] { 1, 2, 3 });
    [Storable]
    public Custom c; 

  }

  public class Custom {
    [Storable]
    public int i;
    [Storable]
    public Root r;
    [Storable]
    public string name = "Serial";
  }

  public class NewSerializationTest {
    public static void Main() {
      Root r = new Root();
      r.c = new Custom();
      r.c.r = r;
      IPrimitiveSerializer[] serializers = {
          new String2XMLSerializer(),
          new Int2XMLSerializer()};
      Serializer s = new Serializer(r, serializers);
      Persistence.XmlFormatter xmlFormatter = new Persistence.XmlFormatter();
      foreach (ISerializationToken token in s) {
        Console.Write(xmlFormatter.Format(token));
      }
      Console.In.ReadLine();
    }
  }
}
